Merge branch 'ab/blame-textconv'
[git/dscho.git] / git-rebase.sh
blobab4afa7dee377707484e7f76c7d44ac955f09397
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano.
6 USAGE='[--interactive | -i] [-v] [--force-rebase | -f] [--no-ff] [--onto <newbase>] (<upstream>|--root) [<branch>] [--quiet | -q]'
7 LONG_USAGE='git-rebase replaces <branch> with a new branch of the
8 same name. When the --onto option is provided the new branch starts
9 out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10 It then attempts to create a new commit for each commit from the original
11 <branch> that does not exist in the <upstream> branch.
13 It is possible that a merge failure will prevent this process from being
14 completely automatic. You will have to resolve any such merge failure
15 and run git rebase --continue. Another option is to bypass the commit
16 that caused the merge failure with git rebase --skip. To restore the
17 original <branch> and remove the .git/rebase-apply working files, use the
18 command git rebase --abort instead.
20 Note that if <branch> is not specified on the command line, the
21 currently checked out branch is used.
23 Example: git-rebase master~1 topic
25 A---B---C topic A'\''--B'\''--C'\'' topic
26 / --> /
27 D---E---F---G master D---E---F---G master
30 SUBDIRECTORY_OK=Yes
31 OPTIONS_SPEC=
32 . git-sh-setup
33 set_reflog_action rebase
34 require_work_tree
35 cd_to_toplevel
37 LF='
39 OK_TO_SKIP_PRE_REBASE=
40 RESOLVEMSG="
41 When you have resolved this problem run \"git rebase --continue\".
42 If you would prefer to skip this patch, instead run \"git rebase --skip\".
43 To restore the original branch and stop rebasing run \"git rebase --abort\".
45 unset newbase
46 strategy=recursive
47 do_merge=
48 dotest="$GIT_DIR"/rebase-merge
49 prec=4
50 verbose=
51 diffstat=$(git config --bool rebase.stat)
52 git_am_opt=
53 rebase_root=
54 force_rebase=
55 allow_rerere_autoupdate=
57 continue_merge () {
58 test -n "$prev_head" || die "prev_head must be defined"
59 test -d "$dotest" || die "$dotest directory does not exist"
61 unmerged=$(git ls-files -u)
62 if test -n "$unmerged"
63 then
64 echo "You still have unmerged paths in your index"
65 echo "did you forget to use git add?"
66 die "$RESOLVEMSG"
69 cmt=`cat "$dotest/current"`
70 if ! git diff-index --quiet --ignore-submodules HEAD --
71 then
72 if ! git commit --no-verify -C "$cmt"
73 then
74 echo "Commit failed, please do not call \"git commit\""
75 echo "directly, but instead do one of the following: "
76 die "$RESOLVEMSG"
78 if test -z "$GIT_QUIET"
79 then
80 printf "Committed: %0${prec}d " $msgnum
82 echo "$cmt $(git rev-parse HEAD^0)" >> "$dotest/rewritten"
83 else
84 if test -z "$GIT_QUIET"
85 then
86 printf "Already applied: %0${prec}d " $msgnum
89 test -z "$GIT_QUIET" &&
90 GIT_PAGER='' git log --format=%s -1 "$cmt"
92 prev_head=`git rev-parse HEAD^0`
93 # save the resulting commit so we can read-tree on it later
94 echo "$prev_head" > "$dotest/prev_head"
96 # onto the next patch:
97 msgnum=$(($msgnum + 1))
98 echo "$msgnum" >"$dotest/msgnum"
101 call_merge () {
102 cmt="$(cat "$dotest/cmt.$1")"
103 echo "$cmt" > "$dotest/current"
104 hd=$(git rev-parse --verify HEAD)
105 cmt_name=$(git symbolic-ref HEAD 2> /dev/null || echo HEAD)
106 msgnum=$(cat "$dotest/msgnum")
107 end=$(cat "$dotest/end")
108 eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
109 eval GITHEAD_$hd='$(cat "$dotest/onto_name")'
110 export GITHEAD_$cmt GITHEAD_$hd
111 if test -n "$GIT_QUIET"
112 then
113 export GIT_MERGE_VERBOSITY=1
115 git-merge-$strategy "$cmt^" -- "$hd" "$cmt"
116 rv=$?
117 case "$rv" in
119 unset GITHEAD_$cmt GITHEAD_$hd
120 return
123 git rerere $allow_rerere_autoupdate
124 die "$RESOLVEMSG"
127 echo "Strategy: $rv $strategy failed, try another" 1>&2
128 die "$RESOLVEMSG"
131 die "Unknown exit code ($rv) from command:" \
132 "git-merge-$strategy $cmt^ -- HEAD $cmt"
134 esac
137 move_to_original_branch () {
138 test -z "$head_name" &&
139 head_name="$(cat "$dotest"/head-name)" &&
140 onto="$(cat "$dotest"/onto)" &&
141 orig_head="$(cat "$dotest"/orig-head)"
142 case "$head_name" in
143 refs/*)
144 message="rebase finished: $head_name onto $onto"
145 git update-ref -m "$message" \
146 $head_name $(git rev-parse HEAD) $orig_head &&
147 git symbolic-ref HEAD $head_name ||
148 die "Could not move back to $head_name"
150 esac
153 finish_rb_merge () {
154 move_to_original_branch
155 git notes copy --for-rewrite=rebase < "$dotest"/rewritten
156 if test -x "$GIT_DIR"/hooks/post-rewrite &&
157 test -s "$dotest"/rewritten; then
158 "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten
160 rm -r "$dotest"
161 say All done.
164 is_interactive () {
165 while test $# != 0
167 case "$1" in
168 -i|--interactive)
169 interactive_rebase=explicit
170 break
172 -p|--preserve-merges)
173 interactive_rebase=implied
175 esac
176 shift
177 done
179 if [ "$interactive_rebase" = implied ]; then
180 GIT_EDITOR=:
181 export GIT_EDITOR
184 test -n "$interactive_rebase" || test -f "$dotest"/interactive
187 run_pre_rebase_hook () {
188 if test -z "$OK_TO_SKIP_PRE_REBASE" &&
189 test -x "$GIT_DIR/hooks/pre-rebase"
190 then
191 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} ||
192 die "The pre-rebase hook refused to rebase."
196 test -f "$GIT_DIR"/rebase-apply/applying &&
197 die 'It looks like git-am is in progress. Cannot rebase.'
199 is_interactive "$@" && exec git-rebase--interactive "$@"
201 while test $# != 0
203 case "$1" in
204 --no-verify)
205 OK_TO_SKIP_PRE_REBASE=yes
207 --continue)
208 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
209 die "No rebase in progress?"
211 git diff-files --quiet --ignore-submodules || {
212 echo "You must edit all merge conflicts and then"
213 echo "mark them as resolved using git add"
214 exit 1
216 if test -d "$dotest"
217 then
218 prev_head=$(cat "$dotest/prev_head")
219 end=$(cat "$dotest/end")
220 msgnum=$(cat "$dotest/msgnum")
221 onto=$(cat "$dotest/onto")
222 GIT_QUIET=$(cat "$dotest/quiet")
223 continue_merge
224 while test "$msgnum" -le "$end"
226 call_merge "$msgnum"
227 continue_merge
228 done
229 finish_rb_merge
230 exit
232 head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
233 onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
234 orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
235 GIT_QUIET=$(cat "$GIT_DIR"/rebase-apply/quiet)
236 git am --resolved --3way --resolvemsg="$RESOLVEMSG" &&
237 move_to_original_branch
238 exit
240 --skip)
241 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
242 die "No rebase in progress?"
244 git reset --hard HEAD || exit $?
245 if test -d "$dotest"
246 then
247 git rerere clear
248 prev_head=$(cat "$dotest/prev_head")
249 end=$(cat "$dotest/end")
250 msgnum=$(cat "$dotest/msgnum")
251 msgnum=$(($msgnum + 1))
252 onto=$(cat "$dotest/onto")
253 GIT_QUIET=$(cat "$dotest/quiet")
254 while test "$msgnum" -le "$end"
256 call_merge "$msgnum"
257 continue_merge
258 done
259 finish_rb_merge
260 exit
262 head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
263 onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
264 orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
265 GIT_QUIET=$(cat "$GIT_DIR"/rebase-apply/quiet)
266 git am -3 --skip --resolvemsg="$RESOLVEMSG" &&
267 move_to_original_branch
268 exit
270 --abort)
271 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
272 die "No rebase in progress?"
274 git rerere clear
275 if test -d "$dotest"
276 then
277 GIT_QUIET=$(cat "$dotest/quiet")
278 move_to_original_branch
279 else
280 dotest="$GIT_DIR"/rebase-apply
281 GIT_QUIET=$(cat "$dotest/quiet")
282 move_to_original_branch
284 git reset --hard $(cat "$dotest/orig-head")
285 rm -r "$dotest"
286 exit
288 --onto)
289 test 2 -le "$#" || usage
290 newbase="$2"
291 shift
293 -M|-m|--m|--me|--mer|--merg|--merge)
294 do_merge=t
296 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
297 --strateg=*|--strategy=*|\
298 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
299 case "$#,$1" in
300 *,*=*)
301 strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
302 1,*)
303 usage ;;
305 strategy="$2"
306 shift ;;
307 esac
308 do_merge=t
310 -n|--no-stat)
311 diffstat=
313 --stat)
314 diffstat=t
316 -v|--verbose)
317 verbose=t
318 diffstat=t
319 GIT_QUIET=
321 -q|--quiet)
322 GIT_QUIET=t
323 git_am_opt="$git_am_opt -q"
324 verbose=
325 diffstat=
327 --whitespace=*)
328 git_am_opt="$git_am_opt $1"
329 case "$1" in
330 --whitespace=fix|--whitespace=strip)
331 force_rebase=t
333 esac
335 --ignore-whitespace)
336 git_am_opt="$git_am_opt $1"
338 --committer-date-is-author-date|--ignore-date)
339 git_am_opt="$git_am_opt $1"
340 force_rebase=t
342 -C*)
343 git_am_opt="$git_am_opt $1"
345 --root)
346 rebase_root=t
348 -f|--f|--fo|--for|--forc|force|--force-r|--force-re|--force-reb|--force-reba|--force-rebas|--force-rebase|--no-ff)
349 force_rebase=t
351 --rerere-autoupdate|--no-rerere-autoupdate)
352 allow_rerere_autoupdate="$1"
355 usage
358 break
360 esac
361 shift
362 done
363 test $# -gt 2 && usage
365 if test $# -eq 0 && test -z "$rebase_root"
366 then
367 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply || usage
368 test -d "$dotest" -o -f "$GIT_DIR"/rebase-apply/rebasing &&
369 die 'A rebase is in progress, try --continue, --skip or --abort.'
372 # Make sure we do not have $GIT_DIR/rebase-apply
373 if test -z "$do_merge"
374 then
375 if mkdir "$GIT_DIR"/rebase-apply 2>/dev/null
376 then
377 rmdir "$GIT_DIR"/rebase-apply
378 else
379 echo >&2 '
380 It seems that I cannot create a rebase-apply directory, and
381 I wonder if you are in the middle of patch application or another
382 rebase. If that is not the case, please
383 rm -fr '"$GIT_DIR"'/rebase-apply
384 and run me again. I am stopping in case you still have something
385 valuable there.'
386 exit 1
388 else
389 if test -d "$dotest"
390 then
391 die "previous rebase directory $dotest still exists." \
392 'Try git rebase (--continue | --abort | --skip)'
396 # The tree must be really really clean.
397 if ! git update-index --ignore-submodules --refresh > /dev/null; then
398 echo >&2 "cannot rebase: you have unstaged changes"
399 git diff-files --name-status -r --ignore-submodules -- >&2
400 exit 1
402 diff=$(git diff-index --cached --name-status -r --ignore-submodules HEAD --)
403 case "$diff" in
404 ?*) echo >&2 "cannot rebase: your index contains uncommitted changes"
405 echo >&2 "$diff"
406 exit 1
408 esac
410 if test -z "$rebase_root"
411 then
412 # The upstream head must be given. Make sure it is valid.
413 upstream_name="$1"
414 shift
415 upstream=`git rev-parse --verify "${upstream_name}^0"` ||
416 die "invalid upstream $upstream_name"
417 unset root_flag
418 upstream_arg="$upstream_name"
419 else
420 test -z "$newbase" && die "--root must be used with --onto"
421 unset upstream_name
422 unset upstream
423 root_flag="--root"
424 upstream_arg="$root_flag"
427 # Make sure the branch to rebase onto is valid.
428 onto_name=${newbase-"$upstream_name"}
429 case "$onto_name" in
430 *...*)
431 if left=${onto_name%...*} right=${onto_name#*...} &&
432 onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
433 then
434 case "$onto" in
435 ?*"$LF"?*)
436 die "$onto_name: there are more than one merge bases"
439 die "$onto_name: there is no merge base"
441 esac
442 else
443 die "$onto_name: there is no merge base"
447 onto=$(git rev-parse --verify "${onto_name}^0") || exit
449 esac
451 # If a hook exists, give it a chance to interrupt
452 run_pre_rebase_hook "$upstream_arg" "$@"
454 # If the branch to rebase is given, that is the branch we will rebase
455 # $branch_name -- branch being rebased, or HEAD (already detached)
456 # $orig_head -- commit object name of tip of the branch before rebasing
457 # $head_name -- refs/heads/<that-branch> or "detached HEAD"
458 switch_to=
459 case "$#" in
461 # Is it "rebase other $branchname" or "rebase other $commit"?
462 branch_name="$1"
463 switch_to="$1"
465 if git show-ref --verify --quiet -- "refs/heads/$1" &&
466 branch=$(git rev-parse -q --verify "refs/heads/$1")
467 then
468 head_name="refs/heads/$1"
469 elif branch=$(git rev-parse -q --verify "$1")
470 then
471 head_name="detached HEAD"
472 else
473 usage
477 # Do not need to switch branches, we are already on it.
478 if branch_name=`git symbolic-ref -q HEAD`
479 then
480 head_name=$branch_name
481 branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
482 else
483 head_name="detached HEAD"
484 branch_name=HEAD ;# detached
486 branch=$(git rev-parse --verify "${branch_name}^0") || exit
488 esac
489 orig_head=$branch
491 # Now we are rebasing commits $upstream..$branch (or with --root,
492 # everything leading up to $branch) on top of $onto
494 # Check if we are already based on $onto with linear history,
495 # but this should be done only when upstream and onto are the same.
496 mb=$(git merge-base "$onto" "$branch")
497 if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
498 # linear history?
499 ! (git rev-list --parents "$onto".."$branch" | sane_grep " .* ") > /dev/null
500 then
501 if test -z "$force_rebase"
502 then
503 # Lazily switch to the target branch if needed...
504 test -z "$switch_to" || git checkout "$switch_to"
505 say "Current branch $branch_name is up to date."
506 exit 0
507 else
508 say "Current branch $branch_name is up to date, rebase forced."
512 # Detach HEAD and reset the tree
513 say "First, rewinding head to replay your work on top of it..."
514 git checkout -q "$onto^0" || die "could not detach HEAD"
515 git update-ref ORIG_HEAD $branch
517 if test -n "$diffstat"
518 then
519 if test -n "$verbose"
520 then
521 echo "Changes from $mb to $onto:"
523 # We want color (if set), but no pager
524 GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
527 # If the $onto is a proper descendant of the tip of the branch, then
528 # we just fast-forwarded.
529 if test "$mb" = "$branch"
530 then
531 say "Fast-forwarded $branch_name to $onto_name."
532 move_to_original_branch
533 exit 0
536 if test -n "$rebase_root"
537 then
538 revisions="$onto..$orig_head"
539 else
540 revisions="$upstream..$orig_head"
543 if test -z "$do_merge"
544 then
545 git format-patch -k --stdout --full-index --ignore-if-in-upstream \
546 $root_flag "$revisions" |
547 git am $git_am_opt --rebasing --resolvemsg="$RESOLVEMSG" &&
548 move_to_original_branch
549 ret=$?
550 test 0 != $ret -a -d "$GIT_DIR"/rebase-apply &&
551 echo $head_name > "$GIT_DIR"/rebase-apply/head-name &&
552 echo $onto > "$GIT_DIR"/rebase-apply/onto &&
553 echo $orig_head > "$GIT_DIR"/rebase-apply/orig-head &&
554 echo "$GIT_QUIET" > "$GIT_DIR"/rebase-apply/quiet
555 exit $ret
558 # start doing a rebase with git-merge
559 # this is rename-aware if the recursive (default) strategy is used
561 mkdir -p "$dotest"
562 echo "$onto" > "$dotest/onto"
563 echo "$onto_name" > "$dotest/onto_name"
564 prev_head=$orig_head
565 echo "$prev_head" > "$dotest/prev_head"
566 echo "$orig_head" > "$dotest/orig-head"
567 echo "$head_name" > "$dotest/head-name"
568 echo "$GIT_QUIET" > "$dotest/quiet"
570 msgnum=0
571 for cmt in `git rev-list --reverse --no-merges "$revisions"`
573 msgnum=$(($msgnum + 1))
574 echo "$cmt" > "$dotest/cmt.$msgnum"
575 done
577 echo 1 >"$dotest/msgnum"
578 echo $msgnum >"$dotest/end"
580 end=$msgnum
581 msgnum=1
583 while test "$msgnum" -le "$end"
585 call_merge "$msgnum"
586 continue_merge
587 done
589 finish_rb_merge